!!ARBfp1.0
# Copyright Brad Anderson 2004

PARAM  mv[4]	     = { state.matrix.modelview };
ATTRIB modelNormal		= fragment.texcoord[1];   # Model space
ATTRIB lightDirModel		= fragment.texcoord[2];
ATTRIB halfAngle		= fragment.texcoord[3];
ATTRIB vertToEyeNormal		= fragment.texcoord[4];

PARAM  zero		= { 0.0, 0.0, 0.0, 0.0 };
PARAM  one		= { 1.0, 1.0, 1.0, 1.0 };
PARAM  two		= { 2.0, 2.0, 2.0, 2.0 };
TEMP   diffuse, t1, t2, theNormal, lightDirectionModel;	 # General purpose temporaries

TEMP texel0, texel1, texel2, lightSide, darkSide, earthColor, specularShade, vertToEye;
TEMP distanceFromLightToFragment, hazeDiffuse;

#normalize the fragment to eye normal
    DP3 vertToEye.w, vertToEyeNormal, vertToEyeNormal;
    RSQ vertToEye.w, vertToEye.w;
    MUL vertToEye, vertToEyeNormal, vertToEye.w;    # t0 now contains the normalized 


#pre-bump normalization
    DP3 theNormal.w, modelNormal, modelNormal;
    RSQ theNormal.w, theNormal.w;
    MUL theNormal, modelNormal, theNormal.w;    # t0 now contains the normalized 
    
#get and massage the bump value
    TEMP bumpMap, yTangent, xTangent, bumpSpace, bumpSpace2;
    TEX bumpMap, fragment.texcoord[0], texture[3], 2D;
#MOV result.color.b, 0;
#MOV result.color.a, 1;
    MUL bumpMap, bumpMap, two;
    SUB bumpMap, bumpMap, 1;
#MOV result.color.r, bumpMap.r;
#MOV result.color.g, bumpMap.g;
    
    MOV yTangent, mv[1];
  #  DP3 yTangent.w, yTangent, yTangent;
  #  RSQ yTangent.w, yTangent.w;
  #  MUL yTangent, yTangent, yTangent.w;    # t0 now contains the normalized 
    
    XPD xTangent, yTangent, theNormal;
    XPD yTangent, xTangent, theNormal;
    
    MUL bumpSpace, xTangent, bumpMap.r;
    MUL bumpSpace2, yTangent, bumpMap.g;
    ADD bumpSpace, bumpSpace, bumpSpace2;
    
    MUL bumpSpace, bumpSpace, 3;
    
%s    ADD theNormal, theNormal, bumpSpace;

# compute normalized vector from fragment to light
    DP3 theNormal.w, theNormal, theNormal;
    RSQ theNormal.w, theNormal.w;
    MUL theNormal, theNormal, theNormal.w;    # t0 now contains the normalized 
    
#diffuse constant = compute the max(dot(Light vector, fragment normal), 0)
    DP3  diffuse.x, theNormal, lightDirModel;
    MAX  diffuse, diffuse.xxxx, zero;
    MOV	 hazeDiffuse, diffuse;
#diffuse = Kd * diffuse constant * light color

# normalized vector from fragment to eye
# half vector is normalize(light vector + the eye vector)
#specular  = Ks * light color * pow(max(dot(N,H),0),  shininess);


    # sample each of the textures
TEX lightSide, fragment.texcoord[0], texture[0], 2D;
TEX texel1, fragment.texcoord[0], texture[1], 2D;
TEX specularShade, fragment.texcoord[0], texture[2], 2D;

    # multiply the dark side together
    SUB  texel2, one, diffuse;
    MUL  texel2, texel2, texel2;
    MUL  texel2, texel2, texel2;
    MUL  texel2, texel2, texel2;
    MUL  texel2, texel2, texel2;
MUL darkSide, texel1, texel2;
MUL darkSide, darkSide, program.env[0];
    
    # multiply the day side by the sun shading
ADD_SAT	diffuse, diffuse, program.env[4].z;
MUL lightSide, lightSide, diffuse;

#specular shading
TEMP	specularCoeff;
    DP3 specularCoeff.w, halfAngle, halfAngle;
    RSQ specularCoeff.w, specularCoeff.w;
    MUL specularCoeff, halfAngle, specularCoeff.w;    # t0 now contains the normalized
DP3_SAT   specularCoeff.x, specularCoeff, theNormal;
POW	specularCoeff, specularCoeff.x, program.env[4].x;
MUL	specularCoeff, specularCoeff, program.env[4].y;

#multiply the specular highlight by the specular map and add into the light side
MUL specularShade, specularShade, specularCoeff;
MUL specularShade, specularShade, program.env[3];   #program.env[3] = specular color
	ADD lightSide, lightSide, specularShade;

	# add the dark side to the light side
	ADD earthColor, lightSide, darkSide;


#calculate the haze over the earth   
TEMP	haze, hazeColor, hazeWeight;
    MUL hazeWeight, hazeWeight, program.env[5].z; 
    SUB_SAT hazeWeight, hazeDiffuse, program.env[5].w;

    DP3 haze.w, vertToEye, theNormal;		    # calculate the intensity, greater at the edge
    MUL haze, haze, program.env[5].y;		    # Multiply in the azimuth scalar, (1 - intensity@perpendicular)
    SUB haze, one, haze.wwww;			    # make the edges bright and the center haze dim
    POW haze, haze.w, program.env[5].x;		    # raise to a power such that simulates the atmosphere distances at center to edge
    POW hazeDiffuse, hazeDiffuse.x, 1.3;
    MUL haze, haze, hazeDiffuse; # rm to see haze	    # scale the haze by the hazeDiffuse light at the point
    
    LRP hazeColor, hazeWeight.x, program.env[1], program.env[2];    # calculate the haze color
    MUL haze, haze, hazeColor;		    #multiply by the haze color
	    ADD earthColor, earthColor, haze;

    # set the pixel
MOV result.color, earthColor;

END